/* $Id: aocolor.h 12 2006-01-11 12:20:51Z mawerick $ */
#ifndef AOCOLOR_H
#define AOCOLOR_H

#include <QVariant>
#include <QList>

class QColor;
class QString;

class AOColor
{
public:
	AOColor(void);
	AOColor( const AOColor& );
	virtual ~AOColor(void) { }

	enum ColorType{ String, Hex3, Hex4 };

	void setName( QString name );
	QString name() const;

	void setColor( QString color );
	void setColor( QColor color );
	void setValue( QString value );
	QString value() const;
	QColor color();

protected:
	QString Name;
	QString Color;
	ColorType Type;
	int r;
	int g;
	int b;
};

inline void AOColor::setName( QString name )
{ Name = name; }

inline QString AOColor::name() const
{ return Name; }

inline void AOColor::setValue( QString value )
{ Color = value; }

inline QString AOColor::value() const
{ return Color; }

class AOColors : public QList<AOColor>
{
public:
	AOColors() { }
    AOColors( const AOColors& l ) : QList<AOColor>(l) { }
    AOColors( const QList<AOColor>& l ) : QList<AOColor>(l) { }
    AOColors( const AOColor& i ) { append(i); }
	virtual ~AOColors() { }

	AOColor getByName( QString name );
	bool updateColor( AOColor color );
};

#endif // AOCOLOR_H
