/* $Id: aocolor_widget.h 14 2006-02-05 11:27:30Z mawerick $ */
#ifndef AOCOLOR_WIDGET_H
#define AOCOLOR_WIDGET_H

#include <QVariant>
#include <QWidget>

class QHBoxLayout;
class QLabel;
class QPushButton;
class AOColor;

class AOColorWidget : public QWidget
{
	Q_OBJECT

public:
	AOColorWidget( QWidget *parent = NULL );
	virtual ~AOColorWidget();

	void setText( QString text );
	void setBGColor( AOColor BGColor );

	void addColorGroup( QString cg );
	void removeColorGroup( QString cg );
	void clear();

	void updateColor();

protected slots:
	virtual void buttonClicked();

signals:
	void clicked( const QStringList &cgs );

protected:
	QHBoxLayout *BaseLayout;
	QLabel *ColorLabel;
	QPushButton *ColorBtn;

	QStringList ColorGroups;
};

#endif // AOCOLOR_WIDGET_H
