/* $Id: basedlg.h 14 2006-02-05 11:27:30Z mawerick $ */
#ifndef BASEDLG_H
#define BASEDLG_H

#include <QVariant>
#include <QDialog>
#include "aocolor.h"

class QTabWidget;
class QStackedWidget;
class QVBoxLayout;
class QHBoxLayout;
class QPushButton;
class QString;
class AdvancedModeDlg;
class BasicModeDlg;
class SettingsDlg;
class AboutDlg;
class LicenseDlg;

class BaseDlg : public QDialog
{
	Q_OBJECT

public:
	BaseDlg( QWidget* parent = 0 );
	~BaseDlg();

	bool loadPrefs();
	void savePrefs();

	void updateColors();
	void updateBGColor();

protected slots:
	virtual void pickColor( const QString& );
	virtual void pickColor( const QStringList& );

	virtual void loadData();
	virtual void saveData();

	virtual void modeChanged( bool mode );

protected:
	QVBoxLayout* BaseDlgLayout;
	QTabWidget* TabWidget;
	QStackedWidget* ColorsTab;

	BasicModeDlg* BasicModeTab;
	AdvancedModeDlg* AdvModeTab;
	SettingsDlg* SettingsTab;
	AboutDlg* AboutTab;
	LicenseDlg* LicenseTab;

	QHBoxLayout* SysLayout;
	QPushButton* SaveBtn;
	QPushButton* CloseBtn;

	AOColor BGColor;

	bool AdvMode;
};

#endif // BASEDLG_H
