/* $Id: basicmode_dlg.h 14 2006-02-05 11:27:30Z mawerick $ */
#ifndef BASICMODE_H
#define BASICMODE_H

#include <QVariant>
#include <QWidget>

class QVBoxLayout;
class QGridLayout;
class QTabWidget;
class QLabel;
class QPushButton;
class AOColor;
class AOColorWidget;

class BasicModeDlg : public QWidget
{
	Q_OBJECT

public:
	BasicModeDlg( QWidget * parent = 0 );
	virtual ~BasicModeDlg();

	void updateColors();
	void setBGColor( AOColor BGColor );

protected slots:
	virtual void buttonClicked( const QStringList& cgs );

signals:
	void pickColor( const QStringList& cgs );

protected:
	QVBoxLayout* BaseLayout;
	QTabWidget* TabWidget;

	/* basic chat */
	QWidget* ChatTab;
	QVBoxLayout* ChatLayout;
	AOColorWidget* ClanBtn;
	AOColorWidget* PGroupBtn;
	AOColorWidget* TeamBtn;
	AOColorWidget* TellBtn;
	AOColorWidget* VicinityBtn;
	AOColorWidget* WhisperBtn;
	AOColorWidget* ShoutBtn;

	/* NPC */
	QWidget* NPCTab;
	QVBoxLayout* NPCLayout;
	AOColorWidget* NPCChatBtn;
	AOColorWidget* NPCOOCBtn;
	AOColorWidget* NPCEmoteBtn;
	AOColorWidget* NPCSystemBtn;
	AOColorWidget* NPCQuestionBtn;
	AOColorWidget* NPCDescriptBtn;
	AOColorWidget* NPCTradeBtn;

	/* combat */
	QWidget* CombatTab;
	QVBoxLayout* CombatLayout;
	AOColorWidget* MeHitByNanoBtn;
	AOColorWidget* OtherHitByNanoBtn;
	AOColorWidget* MonsterHitMeBtn;
	AOColorWidget* PlayerHitMeBtn;
	AOColorWidget* MeHitOtherBtn;
	AOColorWidget* OtherHitOtherBtn;
	AOColorWidget* OtherHitByPetBtn;

	/* misc */
	QWidget* MiscTab;
	QVBoxLayout* MiscLayout;
	AOColorWidget* ShoppingBtn;
	AOColorWidget* TowerBtn;
	AOColorWidget* MeHealedBtn;
	AOColorWidget* MeGotXPBtn;
	AOColorWidget* SkillBtn;
	AOColorWidget* MyPetBtn;
	AOColorWidget* OtherPetBtn;

	QLabel* BasicHelpLabel;
};

#endif // BASICMODE_H
