/* $Id: settings_dlg.h 14 2006-02-05 11:27:30Z mawerick $ */
#ifndef SETTINGS_H
#define SETTINGS_H

#include <QVariant>
#include <QWidget>

class QVBoxLayout;
class QHBoxLayout;
class QLabel;
class QPushButton;
class QLineEdit;
class QCheckBox;
class QString;
class AOColor;

class SettingsDlg : public QWidget
{
	Q_OBJECT

public:
	SettingsDlg( QWidget *parent = 0 );
	virtual ~SettingsDlg();

	QString getAOPath();
	bool confirmAOPath();

	bool backupOriginalData();

	void updateColors();
	void setBGColor( AOColor BGColor );

public slots:
	virtual void setAOPath( const QString &path );
	virtual void setMode( bool mode );

protected slots:
	virtual void browseAOPath();
	virtual void pickBGColor();
	virtual void restoreData();
	virtual void restoreBackup();
	virtual void restoreBundledData();
	virtual void restoreOriginalData();

signals:
	void pickColor( const QString &color );
	void modeChanged( bool mode );
	void reloadData();

protected:
	bool lookupAOPath();

	QVBoxLayout* BaseLayout;
	QHBoxLayout* AOPathLayout;
	QLabel* AOPathLabel;
	QLineEdit* AOPathBox;
	QPushButton* AOPathBtn;
	QLabel* AOPathErrorLabel;
	QPushButton* ReloadBtn;
	QPushButton* RestoreBackupBtn;
	QPushButton* RestoreBundledBtn;
	QPushButton* RestoreOriginalBtn;
	QHBoxLayout* BGColorLayout;
	QLabel* BGColorLabel;
	QPushButton* BGColorBtn;
	QCheckBox* ModeBtn;

	QString AOPath;
};

#endif // SETTINGS_H
